import processing.serial.*;

// change 'portstr' to be whatever port you use in Arduino's Serial Monitor
// On Linux this will look something like "/dev/ttyUSB0".  
// On Windows this will usually be the highest COM port, like "COM7"
// On Mac OS X, it's as below
String portstr = "/dev/tty.usbserial-A7004M7s";
// Replace SOME_SITE.COM with your URL
String urlstr = "http://SOME_SITE.COM/parsed%20color.txt";
String urlstr2 = "http://SOME_SITE.COM/parsing.php";
int refreshTime = 900 * 1000;  // every 15 minutes;
int lastTime;

Serial port;
color c;

PFont font;

void setup() {
  size(500,500);
  frameRate(1);

  font = loadFont("Futura-MediumItalic-48.vlw"); 
  fill(153);
  textFont(font, 48); 
  text(urlstr, 10, height/2); 

  port = new Serial(this, portstr, 9600);
  if( port.output == null ) {
      println("ERROR: Could not open serial port: "+portstr);
      exit();
  }
  delay(10*1000);  // delay to wait for Arduino bootloader, just in case
  
  lastTime = millis() - refreshTime; // make it so we getWebColor at startup
} 

void draw() {
  background( c );

  int n = (int)((refreshTime-(millis()-lastTime))/1000)+1;
  println("countdown to color: "+ n);
  text( n, 10, 50);

  if( millis() - lastTime >= refreshTime ) {
    getWebColor();
    lastTime = millis();
  }
}

// print out responses from Arduino
void serialEvent(Serial p) {
    print( (char)port.read() );
}

void getWebColor() {
  try {
    URL url2 = new URL(urlstr2);
    URLConnection conn2 = url2.openConnection();
    conn2.connect();
    
    URL url = new URL(urlstr);
    URLConnection conn = url.openConnection();
    conn.connect();

    BufferedReader in = new BufferedReader(new InputStreamReader(conn.getInputStream()));
    String inputLine;
    while ((inputLine = in.readLine()) != null) {
      System.out.println("   content: "+inputLine);
      if( inputLine.startsWith("#")) {
        int ic = Integer.decode(inputLine).intValue();
        c = color((ic>>16)&0xff,(ic>>8)&0xff,(ic>>0)&0xff); 
        String cs = Integer.toHexString(ic);
        if(cs.length() == 1) cs = "00000"+cs;  // fix broken toHexString() behavior
        if(cs.length() == 2) cs = "0000"+cs;
        if(cs.length() == 3) cs = "000"+cs; 
        if(cs.length() == 4) cs = "00"+cs;
        if(cs.length() == 5) cs = "0"+cs; 
        println("parsed color #"+cs);
        port.write("#"+cs);
        return;
      }
    }
  }  
  catch (Exception ex) {
    ex.printStackTrace();
    System.out.println("ERROR: "+ex.getMessage());
  }

}
